
require 'term_class'
require 'atom_class'

class BasicConjunction
  attr :basic_conjunction
  attr :vars

  def initialize(basic_conjunction)
     @basic_conjunction = basic_conjunction
     @vars = set_vars
  end 

  def each
    @basic_conjunction.each {|a| yield a}
  end

  def add(atom)
    @basic_conjunction.push(atom)
  end

  # all variables that appear in the basic disjunction
  # no Anon vars
  def set_vars
     t = Terms.new([])
     @basic_conjunction.each do |atom|
        t = t + atom.terms
     end
     t.deleteDuplicates
     @vars = t
  end  

  def getVars
      return @vars
  end

  def size
      return @basic_conjunction.size
  end

  # Returns the only atom contained in the 
  # basic_conjunction 
  def to_atom
      if @basic_conjunction.size == 1 then
         return @basic_conjunction[0]
      end
      # FIXME: Aggiungere eccezione se la funzione
      #  chiamata con una basicConj.size > 1
  end

  def to_s
     str = String.new( @basic_conjunction[0].to_s)
     for n in  1 .. (@basic_conjunction.size - 1)
          str = str + ", " +  @basic_conjunction[n].to_s
     end
     return str
  end

 # Return true if any atom of the basic conjunction contains 
 # anon variables "_"
 def includeAnonVars?
    @basic_conjunction.each do |a|
       if a.includeAnonVars?
          return true
       end
    end
    return false
 end
end
