
require 'literal_class'
require 'set'

class BasicDisjunction
  attr :basic_disjunction
  attr :num_bd
  attr :safeVars
  attr :sharedVars
  attr :unResVars

  def initialize(basic_disjunction)
     @basic_disjunction = basic_disjunction
     @num_bd = 0
     @safeVars = Terms.new([])
     @sharedVars = Terms.new([])
     @unResVars = Terms.new([])
  end 

  def set_num_bd(n)
     @num_bd = n
  end

  def each
    @basic_disjunction.each {|a| yield a}
  end

  def add(literal)
    @basic_disjunction.push(literal)
  end

  def to_s
     str = String.new
     for n in  1 .. (@basic_disjunction.length - 1)
          str = str +  @basic_disjunction[n-1].to_s + " v "
     end
     str = str + @basic_disjunction[@basic_disjunction.length-1].to_s
     return str
  end
 
  def size
      return @basic_disjunction.size
  end

  # Returns the only literal contained in the 
  # basic_conjunction 
  def to_literal
      if @basic_disjunction.size == 1 then
         return @basic_disjunction[0]
      end
      # FIXME: Aggiungere eccezione se la funzione
      #  chiamata con una basicConj.size > 1
  end

  # alla variables contained in the basic disjunction
  def all_vars
     vars = Terms.new([])
     basic_disjunction.each do |lit|
         vars = vars + lit.internal_atom.getVars
     end
     return vars.deleteDuplicates
  end

 def safe_vars
     safe = Terms.new([])
     lit =  @basic_disjunction[0]
     if lit.isNegative == false then
         safe = safe + (lit.internal_atom.getVars)
     else
         return Terms.new([])
     end

     for n in 1 .. (@basic_disjunction.length - 1)
          lit = @basic_disjunction[n]
          if lit.isNegative == false then
             safe = safe & lit.internal_atom.getVars
          else
             return Terms.new([])
          end
     end
     return safe.deleteDuplicates
  end 

  def ==(bd)
     if bd.size != self.size
        return false
     end
     for n in 0..bd.size-1
       if !(bd[n] == self[n])
          return false
       end
     end
     return true
  end

  def [](i)
     return @basic_disjunction[i]
  end

  # builds the Terms of shared variables
  #
  # @body: NFN body containing the basic disjunction
  def set_sharedVars(body)
      vars = self.all_vars - self.safe_vars
      shared = Terms.new([])
      body.each do |bd|
         shared = shared + (vars & bd.safe_vars)
      end
      @sharedVars = shared.deleteDuplicates
  end 
 
  def set_unResVars(body)
      vars = self.all_vars - body.safe_vars
      unRes = Terms.new([])
      body.each do |bd|
         if !(bd == self)
            unRes = unRes + (vars & bd.all_vars)
         end
     end
     @unResVars = unRes.deleteDuplicates
  end
  
end

