


require 'basic_disjunction_class'

class Conjunction

  attr :conj

  def initialize(conj)
     @conj = conj
  end

  def each 
    @conj.each {|c| yield c}
  end

  def to_s
     if @conj.size == 0 then
        return ""
     end
    
     str = String.new
     for n in  1 .. (@conj.length - 1)
          if @conj[n-1].size == 1 then
              str = str +  @conj[n-1].to_s + ", "
          else
              str = str + "(" + @conj[n-1].to_s + ")" + ", "
         end
     end   
    if @conj[@conj.length-1].size == 1 then
       str = str +  @conj[@conj.length-1].to_s 
    else
       str = str + "(" + @conj[@conj.length-1].to_s + ")"
    end
     return str
  end
  
  def add(basic_disjunction)
      @conj.push(basic_disjunction)
  end 

  def size
      @conj.size
  end

  # All safe variables of the conjunction
  def safe_vars
      safe = Terms.new([])
      @conj.each do |basic_disj|
          safe = safe + basic_disj.safe_vars
      end
      return safe.deleteDuplicates
  end

# All safe shared variables of the conjunction
  def shared_vars
      shared = Terms.new([])
      @conj.each do |basic_disj|
          shared = shared + basic_disj.sharedVars
      end
      return shared.deleteDuplicates
  end

  # All variables contained in negative literals of the 
  # conjunction
  def negative_vars
     neg_vars = Terms.new([])
     @conj.each do |basic_disj|
        basic_disj.each do |lit|
          if lit.isNegative == true then
              neg_vars = neg_vars + lit.internal_atom.getVars
           end
        end
     end
     return neg_vars.deleteDuplicates
   end

  # Return true if any negative literal of the conjunction contains 
  # anon variables "_"
  def includeNegLitAnonVars?
    @conj.each do |bd|
        bd.each do |lit|
          if lit.isNegative == true then
            if lit.internal_atom.includeAnonVars?
               return true
            end
          end
        end
    end
    return false
  end
  
  # unrestricted variables of the conjunction
   def unRes_vars
     unRes = Terms.new([])
     @conj.each do |basic_disj|
        unRes = unRes + basic_disj.unResVars
     end
     return unRes.deleteDuplicates
   end
end


