
require 'rule'

class Program

  attr :rules

  def initialize(rules)
     @rules = rules
  end

  def each 
    @rules.each {|r| yield r}
  end

  def to_s
      @rules.to_s
  end
  
  def add(rule)
      @rules.push(rule)
  end 

  def size
      @rules.size
  end

  def rules
     return @rules
  end
end

ab = Atom.new("a",["anna","Y"])
abc = Atom.new("abc",[])
bc = BasicConjunction.new([ab,abc])
d = Disjunction.new([bc, bc , bc, abc])

l = Literal.new(true, abc)
ll = Literal.new(false, ab)
bd = BasicDisjunction.new([l,ll])
c = Conjunction.new(["b"])


r = Rule.new(d,c)
r1 = Rule.new(d,[])

p = Program.new([r])
p.add(r1)

p.each do |r|
  puts r
end

