

require 'term_class'
require 'conjunction_class'
require 'disjunction_class'

class Rule

   attr :head
   attr :body

   def initialize(head,body)
       @head = head
       @body = body
   end

   def to_s
       str = String.new
       if @body.size == 0 then
          str = @head.to_s + "."
       else
          str = @head.to_s + " :- " +  @body.to_s + "."
       end
       return str
   end

   def isSafe
       @head.each do |bc|
          if bc.includeAnonVars?
             return false
          end
       end
       if @body.includeNegLitAnonVars?
          return false
       end
      
       safeHead_vars = (@head.vars_disj & @body.safe_vars)
       safeNeg_vars = @body.negative_vars & @body.safe_vars


       if safeHead_vars.sort == @head.vars_disj.sort && 
                   safeNeg_vars.sort == @body.negative_vars.sort
         return true
       end

       return false 
   end

end


